#extension GL_ARB_texture_rectangle : enable
uniform sampler2DRect u_texColor;
uniform sampler2DRect u_texDepth;
uniform sampler2DRect u_texAreaWeight;
uniform float u_zNear;
uniform float u_zFar;
uniform int u_N;

void main()
{
    vec2 coord = vec2(gl_TexCoord[0]);
    float d = float(texture2DRect(u_texDepth, coord));
    float z = -u_zFar * u_zNear / (d * (u_zFar - u_zNear) - u_zFar);
    float weight = float(texture2DRect(u_texAreaWeight, mod(coord, vec2(u_N)))) / z;
    vec4 color = texture2DRect(u_texColor, coord);
    gl_FragColor.rgb = color.rgb * weight;
    gl_FragColor.a = weight;
}
